
package com.baofoo.Demo;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import net.sf.json.JSONObject;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.*;

public class VDownloadDemo {
	/**
	 * （代付凭证下载）
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {

		String Transid = "TN16909880096759";//商户订单号
		String transferDate="2023-08-02";////交易日期yyyy-MM-dd
        String pfxpath ="D:/CER_EN_DECODE/AgreementPay/TestFoPay/bfkey_100029078@@200004284.pfx";//商户私钥        
        String cerpath = "D:/CER_EN_DECODE/AgreementPay/TestFoPay/bfkey_100029078@@200004284.cer";//宝付公钥
        String pfxpwd = "123456";//私钥密码
        
        String memberId ="100029078";//商户号
        String terminalId = "200004284";//终端号
        
        Map<String,String> HeaderPost = new HashMap<String,String>();
		HeaderPost.put("memberId", memberId);//商户号
		HeaderPost.put("terminalId", terminalId);//终端号
		HeaderPost.put("serviceTp", "T-1001-003-03");//服务编号
		HeaderPost.put("verifyType", "1");//加密方式
		
		Map<String,Object> BodyData = new TreeMap<String,Object>();
		BodyData.put("memberTransId", Transid);//商户订单号
		BodyData.put("noticeUrl", "http://10.1.60.128:8080/ReturnUrl.action");
		BodyData.put("fileType", "2");//文件类型1 PNG 2PDF
		BodyData.put("orderType", "0");//订单类型 默认代付交易 0代付 1票据  3代收协议支付 4 普通代收
		BodyData.put("transferDate", transferDate);//交易日期yyyy-MM-dd
		
		Map<String,Object> contentData = new TreeMap<String,Object>();        
        contentData.put("header", HeaderPost);
        contentData.put("body", BodyData);
        
		JSONObject jsonObjectFromMap = JSONObject.fromObject(contentData);
		String Jsonstr = jsonObjectFromMap.toString();
		Log.Write("序列化："+ Jsonstr);
		
		String base64str = SecurityUtil.Base64Encode(Jsonstr);
		String data_content = RsaCodingUtil.encryptByPriPfxFile(base64str,pfxpath,pfxpwd);		     
		 Map<String,String> PostParm = new HashMap<String,String>();
		 PostParm.put("memberId", memberId);//商户号
		 PostParm.put("terminalId", terminalId);//终端号
		 PostParm.put("veryfyString", "");
		 PostParm.put("verifyType", "1");//加密方式
		 PostParm.put("content", data_content);
		 
		 String PostString  = HttpUtil.RequestForm("https://vgw.baofoo.com/union-gw/api/"+HeaderPost.get("serviceTp")+"/transReq.do", PostParm);
		 
         Log.Write("请求返回："+ PostString);
		 
		 PostString = RsaCodingUtil.decryptByPubCerFile(PostString,cerpath);
		 if(PostString.isEmpty()){//判断解密是否正确。如果为空则宝付公钥不正确
			Log.Write("=====检查解密公钥是否正确！");
		 }
		 PostString = SecurityUtil.Base64Decode(PostString);		 
		 Log.Write("=====返回数据解密结果:"+PostString);
		 
		 Map<String,Object> ArrayData = JXMConvertUtil.JsonConvertHashMap(PostString);//将JSON转化为Map对象。
		 Log.Write("转换为MAP对象："+ArrayData);
		 if(!ArrayData.containsKey("sysRespCode")){
			 throw new Exception("sysRespCode Not Found Key [state]!");
		 }		 
		 Log.Write("sysRespCode:"+ArrayData.get("sysRespCode").toString());
		 
		 if(ArrayData.get("sysRespCode").toString().equals("S_0000")){
			 if(!ArrayData.containsKey("state")){
				 throw new Exception("sysRespCode Not Found Key [state]!");
			 }
			 
			 if(ArrayData.get("state").toString().equals("0000")){
				 Log.Write("获取成功！");
			 }
		 }
	}
		
}
